image: node:10

variables:
  GIT_SUBMODULE_STRATEGY: recursive

build:
  stage: build
  script:
    - CI=true
    - npm install
    - npm run build
  artifacts:
    paths:
      - public
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - node_modules/

test:
  stage: build
  script:
    - npm install
    - npm test
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - node_modules/

pages:
  image: alpine:latest
  stage: deploy
  script:
    - echo "GitLab Pages magic happens here"
  dependencies:
    - build # Pulls in the artifacts from the build stage
  artifacts:
    paths:
      - public # Required artifact of Gitlab pages
  # only:
  #   - master

before_script:
  - apk add git
  - apk add openssh
  - apk add --no-cache lftp
  - pip install mkdocs
  # Add your custom theme if not inside a theme_dir
  # (https://github.com/mkdocs/mkdocs/wiki/MkDocs-Themes)
  - pip install mkdocs-material
  # Add your plugins
  - pip install pygments
  - pip install pymdown-extensions
  - pip install mkdocs-awesome-pages-plugin
  - pip install pyembed-markdown
  - pip install mkdocs-git-revision-date-localized-plugin
  - pip install plantuml-markdown
  - pip install mkdocs-minify-plugin

deploy:
  script:
    - mkdocs build
    - mkdir /root/.ssh                                # Create .ssh directory
    - chmod 700 /root/.ssh                            # Set permissions
    - touch /root/.ssh/known_hosts                    # Create known_hosts files
    - chmod 600 /root/.ssh/known_hosts                # Set permissions
    - ssh-keyscan -H $HOST >> /root/.ssh/known_hosts  # Add server to known_hosts, "set sftp:auto-confirm" does not work
    - lftp -e "mirror -e -P 4 --transfer-all --reverse -X .* --verbose site/ www/; quit" -u $USER,$PASSWORD sftp://$HOST -p 22
  artifacts:
    paths:
      - site
  only:
    - master
